#include <memory.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include "RateTransposer.h"
#include "InterpolateLinear.h"

using namespace soTouch;

TransposerBase::ALGORITHM TransposerBase::algorithm = TransposerBase::LINEAR;


RateTransposer::RateTransposer() : FIFOProcessor()
{
    pTransposer = TransposerBase::newInstance();

    work = new double[128];

}

RateTransposer::~RateTransposer()
{
    delete pTransposer;
    delete[] work;
}


TransposerBase *TransposerBase::newInstance()
{
#ifdef __INTEGER_SAMPLES
    return ::new InterpolateLinearInteger;
#else
    switch (algorithm)
    {
        case LINEAR:
            return new InterpolateLinearFloat();
        default:
            //assert(false);
            return nullptr;
    }
#endif
}
